﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Input;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace PointSnapToLayer
{
    internal class TsquareEditInteractiveOverlay : SnapToLayerEditInteractiveOverlay
    {
        #region Data

        public static Tsquare TSqure = new Tsquare();
        #endregion

        #region Screen refresh

        /// <summary>
        /// Переопределяем функцию отрисовки
        /// </summary>
        /// <param name="canvas"></param>
        protected override void DrawTileCore(GeoCanvas canvas)
        {
            if (TSqure.VerticalSlideway != null)
            {
               //TSqure.UpdateVerticalSlideway(canvas.CurrentWorldExtent);   //обновление до пересечения с экраном
                canvas.DrawLine(TSqure.VerticalSlideway, new GeoPen(GeoColor.SimpleColors.Black), DrawingLevel.LevelOne);
            }

            if (TSqure.HorizontalSlideway != null)
            {
               // TSqure.UpdateHorizontalSlideway(canvas.CurrentWorldExtent);
                canvas.DrawLine(TSqure.HorizontalSlideway, new GeoPen(GeoColor.SimpleColors.Black), DrawingLevel.LevelOne);
            }
            base.DrawTileCore(canvas);
        }

        #endregion

        #region Device Event Handler

        protected override InteractiveResult MouseMoveCore(InteractionArguments interactionArguments)
        {
            #region default values
            if (TSqure.VerticalSlideway == null)
            {
                TSqure.VerticalSlideway = new LineShape(new[]
		                                                    {
		                                                        new Vertex(interactionArguments.WorldX,
		                                                                   interactionArguments.CurrentExtent.
		                                                                    UpperRightPoint.Y),
		                                                        new Vertex(interactionArguments.WorldX,
		                                                                   interactionArguments.CurrentExtent.
		                                                                    LowerRightPoint.Y)
		                                                    });
            }

            if (TSqure.CenterTsquare.CenterPointShape == null)
                TSqure.CenterTsquare.CenterPointShape = new PointShape(interactionArguments.WorldX, interactionArguments.WorldY);

            #endregion

            double deltaX = interactionArguments.WorldX - TSqure.CenterTsquare.CenterPointShape.X;
            double deltaY = interactionArguments.WorldY - TSqure.CenterTsquare.CenterPointShape.Y;
            TSqure.VerticalSlideway.TranslateByOffset(deltaX, deltaY);
           
            TSqure.CenterTsquare.CenterPointShape = new PointShape(interactionArguments.WorldX, interactionArguments.WorldY);

            TSqure.RefreshSlideways();  //обновляем позиции составляющих

            Draw(interactionArguments.CurrentExtent, OverlayRefreshType.Redraw);
            return base.MouseMoveCore(interactionArguments);
        }

        #endregion


    }
}